
Public

Type ib3d_GUIElement Extends ib3d_base
	' maps a b3d GUIElement to an IGUIElement
	Global GUIToElement:THashtable = Null
	Global GUIElementList:TList = Null

	Field _element:IGUIElement = Null

	Method New()
		' setup the IGUIElement to b3d_entity map
		If Not GUIToElement Then GUIToElement = New THashtable
		If Not GUIElementList Then GUIElementList = New TList
		GUIElementList.AddLast(Self)
	EndMethod

	Method Destroy()
		GUIToElement.RemoveKey(_element.handle)
		GUIElementList.Remove(Self)

		If _userdata Then _userdata.Clear()
		
		' remove from the element graph
		_element.Remove()
		_element=Null
	EndMethod

	Method setElement(element:IGUIElement)
		If Not element.IsValid() Then RuntimeError "setElement is invalid"
		GUIToElement.Add(element.handle, Self, True)
		_element = element
	EndMethod
	
	Function findElement:ib3d_GUIElement(element:IGUIElement)
		If Not element Or Not element.IsValid() Then Return Null
		Local temp:TKeyValuePair = GUIToElement.ContainsKey(element.handle)
		If Not temp Return Null Else Return ib3d_GUIElement(temp.Value)
	EndFunction
		
EndType

Type GUI_TEXT Extends ib3d_GUIElement
	Method create(text:String, x:Int, y:Int)
EndType

Type ib3d_GUIEventHandler
	Method OnEvent(element:ib3d_GUIElement, event_type:Int) Abstract
EndType