' TODO: CreateMirror

Type PIVOT Extends ib3d_Entity
	Global PivotList:TList=Null
							
	Method New()
		If Not PivotList Then PivotList=New TList
		PivotList.AddLast(Self)
	EndMethod
	
	Method Destroy()
		Super.Destroy()
		PivotList.Remove(Self)
	EndMethod
EndType

Rem
bbdoc: Creates a pivot entity
returns: The new pivot entity
about: <i>Parameters</i>
<ul>
<li>parent:ib3d_Entity - parent entity of pivot</li>
</ul>
A pivot entity is an invisible point in 3D space that's main use is to act as a parent entity to other entities. The pivot can then be used to control lots of entities at once, or act as new centre of rotation for other entities. <br><br>
To enforce this relationship; use EntityParent or make use of the optional parent entity parameter available with all entity load/creation commands. <br><br>
Indeed, this parameter is also available with the CreatePivot command if you wish for the pivot to have a parent entity itself. 
EndRem
Function ib3d_CreatePivot:PIVOT(parent:ib3d_Entity=Null)
	If Not _g_ib3d_engine Then RuntimeError "iB3D engine has not been initialized"
	Return _g_ib3d_engine.createPivot(parent)
EndFunction

Rem
CreatePivot - ISceneManager.addEmptySceneNode()
CreateMirror - ISceneManager.addAnimatedMeshSceneNode(), ISceneManager.addHillPlaneMesh() -> NOTE: change material to shiny

mirror node at:
http://irrlicht.sourceforge.net/phpBB2/viewtopic.php?t=13812&highlight=mirror+node
EndRem