'*****Sprite type ******

Type SPRITE Extends MESH
    
    Global SpriteList:TList=Null
    Global cont:Int 'addHillPlaneMesh requests a diferent name for each mesh, don't know why, yet...
    Global spMesh:IAnimatedMesh=Null
    
    Field tex:texture=Null
    Field angle:Float  ' rotatesprite
    'Field handle_x:Float,handle_y:Float 'todo 
    Field view_mode:Int=1
    Global rot1:Vector3df,rot3:Vector3df,rot4:Vector3df 'update vectors
    
    Method New()
        If Not MeshList Then MeshList=New TList
        MeshList.AddLast(Self)
        If Not SpriteList Then SpriteList=New TList
        SpriteList.AddLast(Self)
    EndMethod
    
    Method Destroy()
        'If tex Then tex.Free()  
        tex=Null
        _mesh=Null
        Super.Destroy()
        MeshList.Remove(Self)        
        SpriteList.Remove(Self)        
    EndMethod
        
	Method SetViewMode(mode:Int)
	    If mode>0 And mode<5
	        view_mode=mode
	    End If
	EndMethod

	Method RotateByAngle(rot_angle:Float)
	   	angle:+rot_angle
	   	
		Local m:Matrix4=Matrix4.create()
		m.setRotationDegrees(_VECTOR3DF(0,0,angle))
		_g_ib3d_engine.smgr.getMeshManipulator().transformMesh(IAnimatedMesh(_mesh).getMesh(0),m)
	EndMethod

	Method Scale(x_scale:Float,y_scale:Float,z_scale:Float = 1)
		Scale(x_scale,y_scale,1)
	EndMethod

    Function Update(cam:CAMERA)
        Local cam_rot:Vector3df
        Local temp:SPRITE
        If spritelist<>Null
            rot1=cam._node.GetRotation()
            rot1.setZ(0)
            rot3=cam._node.GetRotation()
            rot4=cam._node.GetRotation()
            rot4.setx(0)
            
            For temp=EachIn SpriteList
                            
                Select temp.view_mode  'B3D Sprite view modes
                    Case 1                        
                        temp._node.SetRotation(rot1)'cam_rot)                        
                    Case 2
                        'FREE
                    Case 3                        
                        temp._node.SetRotation(rot3)'cam_rot)    
                    Case 4
                        temp._node.SetRotation(rot4)'cam_rot)    
                End Select        
            Next
        End If            
    End Function
End Type

Function ib3d_CreateSprite:SPRITE(rotate_mode:Int=1,parent:ib3d_Entity=Null)
    If Not _g_ib3d_engine Then RuntimeError "iB3D engine has not been initialized"
    Return _g_ib3d_engine.CreateSprite(rotate_mode,parent)
EndFunction

Function ib3d_LoadSprite:SPRITE(file:String,flag:Int=EMT_SOLID,rotate_mode:Int=1,parent:ib3d_Entity=Null)
    If Not _g_ib3d_engine Then RuntimeError "iB3D engine has not been initialized"
    Return _g_ib3d_engine.LoadSprite(file,flag,rotate_mode,parent)
EndFunction

Function ib3d_SpriteViewMode(sp:SPRITE,mode:Int)
	sp.SetViewMode(mode)
End Function
    
Function ib3d_RotateSprite(sp:SPRITE,angle:Float)
	sp.RotateByAngle(angle)
End Function

Function ib3d_ScaleSprite(sp:SPRITE,x_scale:Float,y_scale:Float)
    sp.Scale(x_scale,y_scale)
End Function