//------------------------------------------------------------------------------------
// BMXBinder wrappers
//------------------------------------------------------------------------------------


class BMXBinder
{
public:
	s32 binding;
	void (*BMXBinder_deconstructor)(s32 binding);

	BMXBinder()
	{
		binding=0;
		BMXBinder_deconstructor=0;
	}

	void setBinding(s32 newbinding)
	{
		binding=newbinding;
	}

	void bindDeconstructor(void (*bindDecon)(s32 binding))
	{
		BMXBinder_deconstructor=bindDecon;
	}

	s32 getBinding()
	{
		return binding;
	}

	~BMXBinder()
	{
		if (BMXBinder_deconstructor)
			BMXBinder_deconstructor(binding);	
	}
};

extern "C" void BMXBinder_bindDeconstructor(BMXBinder* bind,void (*bindDecon)(s32 binding))
{
	if (bind)
		bind->bindDeconstructor(bindDecon);
}

extern "C" void BMXBinder_setBinding(BMXBinder* bind,s32 newbinding)
{
	if (bind)
		bind->setBinding(newbinding);
}

extern "C" s32 BMXBinder_getBinding(BMXBinder* bind)
{
	if (bind)
		return bind->getBinding();
	else return 0;
}

extern "C" void BMXBinder_del(BMXBinder* del)
{
	if (del)
		delete del;
		
	del=0;
}


