' ------------------------------------------------------------------------------------
' irr::core::matrix4 wrappers
' ------------------------------------------------------------------------------------

Public

Extern

	Function IrrCore_Matrix4_new:Int(eConstructor:Int=EM4CONST_IDENTITY)
	Function IrrCore_Matrix4_newFromMatrix4:Int(pMatrix4:Int,eConstructor:Int=EM4CONST_COPY)
	Function IrrCore_Matrix4_del(pMatrix:Int)
	' do not delete
	Function IrrCore_Matrix4_makeIdentity:Int(pMatrix:Int) ' returns matrix4*
	Function IrrCore_Matrix4_isIdentity:Int(pMatrix:Int)
	' do not delete
	Function IrrCore_Matrix4_setTranslation:Int(pMatrix:Int,pTranslation:Int) ' returns matrix4*
	Function IrrCore_Matrix4_getTranslation:Int(pMatrix:Int)
	' do not delete
	Function IrrCore_Matrix4_setInverseTranslation:Int(pMatrix:Int,pTranslation:Int) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_setRotationRadians:Int(pMatrix:Int,pRotation:Int) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_setRotationDegrees:Int(pMatrix:Int,pRotation:Int) ' returns matrix4*
	Function IrrCore_Matrix4_getRotationDegrees:Int(pMatrix:Int)
	' do not delete
	Function IrrCore_Matrix4_setInverseRotationRadians:Int(pMatrix:Int,pRotation:Int) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_setInverseRotationDegrees:Int(pMatrix:Int,pRotation:Int) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_setScale:Int(pMatrix:Int,pScale:Int) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_setScaleFromFloat:Int(pMatrix:Int,scale:Float) ' returns matrix4*
	Function IrrCore_Matrix4_inverseTranslateVect(pMatrix:Int,pVect:Int)
	Function IrrCore_Matrix4_inverseRotateVect(pMatrix:Int,pVect:Int)
	Function IrrCore_Matrix4_rotateVect(pMatrix:Int,pVect:Int)
	Function IrrCore_Matrix4_rotateVectToVect(pMatrix:Int,pVector3df_out:Int,pVector3df_in:Int)
	Function IrrCore_Matrix4_rotateVectToFloatArray(pMatrix:Int,out:Float Ptr,pVector3df_in:Int)	
	Function IrrCore_Matrix4_transformVectIO(pMatrix:Int,pIn:Int,pOut:Int)
	Function IrrCore_Matrix4_transformVect(pMatrix:Int,pVect:Int)
	Function IrrCore_Matrix4_transformVectArray(pMatrix:Int,out:Float Ptr,pVector3df_in:Int)
	Function IrrCore_Matrix4_translateVect(pMatrix:Int,pVect:Int)
	Function IrrCore_Matrix4_transformPlaneIO(pMatrix:Int,pIn:Int,pOut:Int)
	Function IrrCore_Matrix4_transformPlane(pMatrix:Int,pPlane:Int)
	Function IrrCore_Matrix4_transformBox(pMatrix:Int,pBox:Int)
	Function IrrCore_Matrix4_transformBoxEx(pMatrix:Int,pBox:Int)
	Function IrrCore_Matrix4_multiplyWith1x4Matrix(pMatrix:Int,mat:Float Ptr)
	Function IrrCore_Matrix4_makeInverse:Int(pMatrix:Int)
	Function IrrCore_Matrix4_getInverse:Int(pMatrix:Int,pOut:Int)
	Function IrrCore_Matrix4_interpolate:Int(pMatrix:Int,pB:Int,time:Float)
	Function IrrCore_Matrix4_getTransposed:Int(pMatrix:Int)	
	' do not delete
	Function IrrCore_Matrix4_buildProjectionMatrixPerspectiveFovRH:Int(pMatrix:Int,fieldOfViewRadians:Float,aspectRatio:Float,zNear:Float,zFar:Float) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_buildProjectionMatrixPerspectiveFovLH:Int(pMatrix:Int,fieldOfViewRadians:Float,aspectRatio:Float,zNear:Float,zFar:Float) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_buildProjectionMatrixPerspectiveRH:Int(pMatrix:Int,widthOfViewVolume:Float,heightOfViewVolume:Float,zNear:Float,zFar:Float) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_buildProjectionMatrixPerspectiveLH:Int(pMatrix:Int,widthOfViewVolume:Float,heightOfViewVolume:Float,zNear:Float,zFar:Float) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_buildProjectionMatrixOrthoLH:Int(pMatrix:Int,widthOfViewVolume:Float,heightOfViewVolume:Float,zNear:Float,zFar:Float) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_buildProjectionMatrixOrthoRH:Int(pMatrix:Int,widthOfViewVolume:Float,heightOfViewVolume:Float,zNear:Float,zFar:Float) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_buildCameraLookAtMatrixLH:Int(pMatrix:Int,pPosition:Int,pTarget:Int,pUpVector:Int) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_buildCameraLookAtMatrixRH:Int(pMatrix:Int,pPosition:Int,pTarget:Int,pUpVector:Int) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_buildShadowMatrix:Int(pMatrix:Int,pLight:Int,pPlane:Int,point:Float=1.0) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_buildNDCToDCMatrix:Int(pMatrix:Int,pRecti_area:Int,zScale:Float) ' returns matrix4*
	Function IrrCore_Matrix4_elementAt:Float(pMatrix:Int,row:Int,column:Int)
	Function IrrCore_Matrix4_pointer:Float Ptr(pMatrix4_matrix:Int) ' returns f32*
	Function IrrCore_Matrix4_Eq:Int(pMatrix:Int,pOther:Int)
	Function IrrCore_Matrix4_EqEq:Int(pMatrix:Int,pOther:Int)
	Function IrrCore_Matrix4_NotEq:Int(pMatrix:Int,pOther:Int)
	Function IrrCore_Matrix4_MultEq:Int(pMatrix:Int,pOther:Int)
	Function IrrCore_Matrix4_Mult:Int(pMatrix:Int,pOther:Int)
	Function IrrCore_Matrix4_getScale(pMatrix:Int) ' returns vector3df* 
	
	Function IrrCore_Matrix4_Idx:Float Ptr(pMatrix4:Int,index:Int) ' returns f32*
	Function IrrCore_Matrix4_EqScalar:Int(pMatrix4:Int,scalar:Float) ' returns matrix4* 
	Function IrrCore_Matrix4_MultEqScalar:Int(pMatrix4:Int,scalar:Float) ' returns matrix4* 
	' must delete ptr
	Function IrrCore_Matrix4_MultScalar:Int(pMatrix4:Int,scalar:Float) ' returns matrix4* 
	Function IrrCore_Matrix4_PlusEq:Int(pMatrix4:Int,pMatrix4_other:Int) ' returns matrix4* 
	' must delete ptr
	Function IrrCore_Matrix4_Plus:Int(pMatrix4:Int,pMatrix4_other:Int) ' returns matrix4* 
	Function IrrCore_Matrix4_MinusEq:Int(pMatrix4:Int,pMatrix4_other:Int) ' returns matrix4* 
	' must delete ptr
	Function IrrCore_Matrix4_Minus:Int(pMatrix4:Int,pMatrix4_other:Int) ' returns matrix4* 
	Function IrrCore_Matrix4_setbyproduct_nocheck(pMatrix4:Int,pMatrix4_other_a:Int,pMatrix4_other_b:Int)
	Function IrrCore_Matrix4_setbyproduct(pMatrix4:Int,pMatrix4_other_a:Int,pMatrix4_other_b:Int)
	Function IrrCore_Matrix4_isIdentity_integer_base:Int(pMatrix4:Int)
	Function IrrCore_Matrix4_rotateVectToOut(pMatrix4:Int,out:Float Ptr,pVector3df_in:Int)
	Function IrrCore_Matrix4_getInversePrimitive:Int(pMatrix4:Int,pMatrix4_out:Int)
	Function IrrCore_Matrix4_getTransposedToDest(pMatrix4:Int,pMatrix4_dest:Int)
	' do not delete
	Function IrrCore_Matrix4_setTextureRotationCenter:Int(pMatrix4:Int,rotateRad:Float) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_setTextureTranslate:Int(pMatrix4:Int,x:Float,y:Float) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_setTextureScale:Int(pMatrix4:Int,sx:Float,sy:Float) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_setTextureScaleCenter:Int(pMatrix4:Int,sx:Float,sy:Float) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_buildTextureTransform:Int(pMatrix4:Int,rotateRad:Float,pvector2df_rotatecenter:Int,pVector2df_translate:Int,pVector2df_scale:Int) ' returns matrix4*
	' do not delete
	Function IrrCore_Matrix4_setM:Int(pMatrix4:Int,data:Float Ptr) ' returns matrix4*
	Function IrrCore_Matrix4_setDefinitelyIdentityMatrix(pMatrix4:Int,bIsDefinitelyIdentityMatrix:Int)
	Function IrrCore_Matrix4_getDefinitelyIdentityMatrix:Int(pMatrix4:Int)
	' do not delete
	Function IrrCore_Matrix4_setTextureTranslateTransposed:Int(pMatrix4:Int, x:Float, y:Float) ' returns matrix4*

EndExtern
