' ------------------------------------------------------------------------------------
' irr::core::position2d<f32> wrappers (done)
' ------------------------------------------------------------------------------------
Public

Type Position2df Extends IrrBase Final

	Method EqEq:Int(pOther:Position2df)
		Return IrrCore_Position2df_EqEq(handle,pOther.handle)
	EndMethod
	Method NotEq:Int(pOther:Position2df)
		Return IrrCore_Position2df_NotEq(handle,pOther.handle)
	EndMethod
	Method Eq:Position2df(pOther:Position2df)
		Return Position2df.createFromHandle(IrrCore_Position2df_Eq(handle,pOther.handle),True)
	EndMethod
	Method Plus:Position2df(pOther:Position2df)
		Return createFromHandle(IrrCore_Position2df_Plus(handle,pOther.handle))
	EndMethod
	Method Minus:Position2df(pOther:Position2df)
		Return createFromHandle(IrrCore_Position2df_Minus(handle,pOther.handle))
	EndMethod	

	Method PlusDim:Position2df(other:Dimension2df)
		Return Position2df.createFromHandle(IrrCore_Position2df_PlusDim(handle,other.handle),True)
	EndMethod
	
	Method MinusDim:Position2df(other:Dimension2df)
		Return Position2df.createFromHandle(IrrCore_Position2df_MinusDim(handle,other.handle),True)
	EndMethod
	
	Method Mult:Position2df(other:Position2df)
		Return Position2df.createFromHandle(IrrCore_Position2df_Mult(handle,other.handle),True)
	EndMethod
	
	Method MultScalar:Position2df(scalar:Float)
		Return Position2df.createFromHandle(IrrCore_Position2df_MultScalar(handle,scalar),True)
	EndMethod
	
	Method PlusEq:Position2df(other:Position2df)
		Return Position2df.createFromHandle(IrrCore_Position2df_PlusEq(handle,other.handle),False)
	EndMethod
	
	Method MinusEq:Position2df(other:Position2df)
		Return Position2df.createFromHandle(IrrCore_Position2df_MinusEq(handle,other.handle),False)
	EndMethod

	Method PlusEqDim:Position2df(other:Dimension2df)
		Return Position2df.createFromHandle(IrrCore_Position2df_PlusEqDim(handle,other.handle),False)
	EndMethod
	
	Method MinusEqDim:Position2df(other:Dimension2df)
		Return Position2df.createFromHandle(IrrCore_Position2df_MinusEqDim(handle,other.handle),False)
	EndMethod

	'--------------------------------------------
	' get/set routines
	'--------------------------------------------
	
	Method getX:Float()
		Return IrrCore_Position2df_getX(handle)
	EndMethod
	Method getY:Float()
		Return IrrCore_Position2df_getY(handle)
	EndMethod
	Method setX(x:Float)
		IrrCore_Position2df_setX(handle,x)
	EndMethod
	Method setY(y:Float)
		IrrCore_Position2df_setY(handle,y)
	EndMethod
	
	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function create:Position2df(x:Float=0,y:Float=0)
		Return createFromHandle(IrrCore_Position2df_new(x,y))
	EndFunction
	
	Function createFromPos:Position2df(pPos:Position2df)
		Return createFromHandle(IrrCore_Position2df_newFromPos(pPos.handle))
	EndFunction
	
	Function createFromHandle:Position2df(pPos:Int,bMustDel:Int=True)
		If Not pPos Then Return Null
		Local oRetVal:Position2df=New Position2df
		oRetVal.attach(pPos,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Position2df_del(handle)
	EndMethod	
EndType