' ------------------------------------------------------------------------------------
' irr::core::position2d<s32> wrappers (done)
' ------------------------------------------------------------------------------------
Public

Type Position2di Extends IrrBase Final

	Method EqEq:Int(pOther:Position2di)
		Return IrrCore_Position2di_EqEq(handle,pOther.handle)
	EndMethod
	Method NotEq:Int(pOther:Position2di)
		Return IrrCore_Position2di_NotEq(handle,pOther.handle)
	EndMethod

	Method Eq:Position2di(pOther:Position2di)
		Return Position2di.createFromHandle(IrrCore_Position2di_Eq(handle,pOther.handle),True)
	EndMethod
	Method Plus:Position2di(pOther:Position2di)
		Return createFromHandle(IrrCore_Position2di_Plus(handle,pOther.handle))
	EndMethod
	Method Minus:Position2di(pOther:Position2di)
		Return createFromHandle(IrrCore_Position2di_Minus(handle,pOther.handle))
	EndMethod	

	Method PlusDim:Position2di(other:Dimension2di)
		Return Position2di.createFromHandle(IrrCore_Position2di_PlusDim(handle,other.handle),True)
	EndMethod
	
	Method MinusDim:Position2di(other:Dimension2di)
		Return Position2di.createFromHandle(IrrCore_Position2di_MinusDim(handle,other.handle),True)
	EndMethod
	
	Method Mult:Position2di(other:Position2di)
		Return Position2di.createFromHandle(IrrCore_Position2di_Mult(handle,other.handle),True)
	EndMethod
	
	Method MultScalar:Position2di(scalar:Int)
		Return Position2di.createFromHandle(IrrCore_Position2di_MultScalar(handle,scalar),True)
	EndMethod
	
	Method PlusEq:Position2di(other:Position2di)
		Return Position2di.createFromHandle(IrrCore_Position2di_PlusEq(handle,other.handle),False)
	EndMethod
	
	Method MinusEq:Position2di(other:Position2di)
		Return Position2di.createFromHandle(IrrCore_Position2di_MinusEq(handle,other.handle),False)
	EndMethod

	Method PlusEqDim:Position2di(other:Dimension2di)
		Return Position2di.createFromHandle(IrrCore_Position2di_PlusEqDim(handle,other.handle),False)
	EndMethod
	
	Method MinusEqDim:Position2di(other:Dimension2di)
		Return Position2di.createFromHandle(IrrCore_Position2di_MinusEqDim(handle,other.handle),False)
	EndMethod

	'--------------------------------------------
	' get/set routines
	'--------------------------------------------
	
	Method getX:Int()
		Return IrrCore_Position2di_getX(handle)
	EndMethod
	Method getY:Int()
		Return IrrCore_Position2di_getY(handle)
	EndMethod
	Method setX(x:Int)
		IrrCore_Position2di_setX(handle,x)
	EndMethod
	Method setY(y:Int)
		IrrCore_Position2di_setY(handle,y)
	EndMethod
	
	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function create:Position2di(x:Int=0,y:Int=0)
		Return createFromHandle(IrrCore_Position2di_new(x,y))
	EndFunction
	
	Function createFromPos:Position2di(pPos:Position2di)
		Return createFromHandle(IrrCore_Position2di_newFromPos(pPos.handle))
	EndFunction
	
	Function createFromHandle:Position2di(pPos:Int,bMustDel:Int=True)
		If Not pPos Then Return Null
		Local oRetVal:Position2di=New Position2di
		oRetVal.attach(pPos,bMustDel)
		Return oRetVal
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrCore_Position2di_del(handle)
	EndMethod	
EndType