Public

' ------------------------------------------------------------------------------------
' irr::gui::IGUIEnvironment wrappers
' do Not Delete a pointer To this
' ------------------------------------------------------------------------------------
Type IGUIEnvironment Extends IReferenceCounted Final

	Function createFromHandle:IGUIEnvironment(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IGUIEnvironment=New IGUIEnvironment
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction	

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrGUI_IGUIEnvironment_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrGUI_IGUIEnvironment_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrGUI_IGUIEnvironment_grab(handle)
	EndMethod
		
	Method addButton:IGUIButton(rectangle:Recti,parent:IGUIElement=Null,id:Int=-1,text:String=Null,tooltiptext:String=Null)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIButton.createFromHandle(IrrGUI_IGUIEnvironment_addButton(handle,rectangle.handle,parent.handle,id,StringToWChar(text),StringToWChar(tooltiptext)))
	EndMethod

	Method addCheckBox:IGUICheckBox(bChecked:Int,rectangle:Recti,parent:IGUIElement=Null,id:Int=-1,text:String=Null)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUICheckBox.createFromHandle(IrrGUI_IGUIEnvironment_addCheckBox(handle,bChecked,rectangle.handle,parent.handle,id,StringToWChar(text)))
	EndMethod

	Method addComboBox:IGUIComboBox(rectangle:Recti,parent:IGUIElement=Null,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIComboBox.createFromHandle(IrrGUI_IGUIEnvironment_addComboBox(handle,rectangle.handle,parent.handle,id))
	EndMethod
	
	Method addContextMenu:IGUIContextMenu(rectangle:Recti,parent:IGUIElement=Null,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIContextMenu.createFromHandle(IrrGUI_IGUIEnvironment_addContextMenu(handle,rectangle.handle,parent.handle,id))
	EndMethod
	
	Method addEditBox:IGUIEditBox(text:String,rectangle:Recti,bBorder:Int=True,parent:IGUIElement=Null,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIEditBox.createFromHandle(IrrGUI_IGUIEnvironment_addEditBox(handle,StringToWChar(text),rectangle.handle,bBorder,parent.handle,id))
	EndMethod
	
	Method addFileOpenDialog:IGUIFileOpenDialog(title:String=Null,bModal:Int=True,parent:IGUIElement=Null,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIFileOpenDialog.createFromHandle(IrrGUI_IGUIEnvironment_addFileOpenDialog(handle,StringToWChar(title),bModal,parent.handle,id))
	EndMethod

	Method addColorSelectionDialog:IGUIColorSelectDialog(title:String=Null,bModal:Int=True,parent:IGUIElement=Null,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIColorSelectDialog.createFromHandle(IrrGUI_IGUIEnvironment_addColorSelectDialog(handle,StringToWChar(title),bModal,parent.handle,id),False)
	EndMethod

	Method addImage:IGUIImage(rectangle:Recti,parent:IGUIElement=Null,id:Int=-1,text:String=Null)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIImage.createFromHandle(IrrGUI_IGUIEnvironment_addImage(handle,rectangle.handle,parent.handle,id,StringToWChar(text)))
	EndMethod

	Method addImageFromTexture:IGUIImage(image:ITexture,pos:Position2di,bUseAlphaChannel:Int=True,parent:IGUIElement=Null,id:Int=-1,text:String=Null)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIImage.createFromHandle(IrrGUI_IGUIEnvironment_addImageFromTexture(handle,image.handle,pos.handle,bUseAlphaChannel,parent.handle,id,StringToWChar(text)))
	EndMethod
	
	Method addInOutFader:IGUIInOutFader(rectangle:Recti,parent:IGUIElement=Null,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIInOutFader.createFromHandle(IrrGUI_IGUIEnvironment_addInOutFader(handle,rectangle.handle,parent.handle,id))
	EndMethod

	Method addListBox:IGUIListBox(rectangle:Recti,parent:IGUIElement=Null,id:Int=-1,bDrawBackground:Int=False)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIListBox.createFromHandle(IrrGUI_IGUIEnvironment_addListBox(handle,rectangle.handle,parent.handle,id,bDrawBackground))
	EndMethod

	Method addMenu:IGUIContextMenu(parent:IGUIElement=Null,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIContextMenu.createFromHandle(IrrGUI_IGUIEnvironment_addMenu(handle,parent.handle,id))
	EndMethod
	
	Method addMeshViewer:IGUIMeshViewer(rectangle:Recti,parent:IGUIElement,id:Int=-1,text:String=Null)
		Return IGUIMeshViewer.createFromHandle(IrrGUI_IGUIEnvironment_addMeshViewer(handle,rectangle.handle,parent.handle,id,StringToWChar(text)))
	EndMethod

	Method addMessageBox:IGUIWindow(caption:String,text:String=Null,bModal:Int=True,flags:Int=EMBF_OK,parent:IGUIElement=Null,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIWindow.createFromHandle(IrrGUI_IGUIEnvironment_addMessageBox(handle,StringToWChar(caption),StringToWChar(text),bModal,flags,parent.handle,id))
	EndMethod
	
	Method addScrollBar:IGUIScrollBar(bHorizontal:Int,rectangle:Recti,parent:IGUIElement=Null,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIScrollBar.createFromHandle(IrrGUI_IGUIEnvironment_addScrollBar(handle,bHorizontal,rectangle.handle,parent.handle,id))
	EndMethod

	Method addStaticText:IGUIStaticText(text:String,rectangle:Recti,bBorder:Int=False,bWordWrap:Int=True,parent:IGUIElement=Null,id:Int=-1,bFillBackground:Int=False)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIStaticText.createFromHandle(IrrGUI_IGUIEnvironment_addStaticText(handle,StringToWChar(text),rectangle.handle,bBorder,bWordWrap,parent.handle,id,bFillBackground))
	EndMethod
	
	Method addTab:IGUITab(rectangle:Recti,parent:IGUIElement=Null,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUITab.createFromHandle(IrrGUI_IGUIEnvironment_addTab(handle,rectangle.handle,parent.handle,id))
	EndMethod
	
	Method addTabControl:IGUITabControl(rectangle:Recti,parent:IGUIElement=Null,bFillbackground:Int=False,bBorder:Int=True,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUITabControl.createFromHandle(IrrGUI_IGUIEnvironment_addTabControl(handle,rectangle.handle,parent.handle,bFillbackground,bBorder,id))
	EndMethod

	Method addToolBar:IGUIToolBar(parent:IGUIElement=Null,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIToolBar.createFromHandle(IrrGUI_IGUIEnvironment_addToolBar(handle,parent.handle,id))
	EndMethod

	Method addWindow:IGUIWindow(rectangle:Recti,bModal:Int=False,text:String=Null,parent:IGUIElement=Null,id:Int=-1)
		If parent=Null Then parent=New IGUIElement ' default handle to 0
		Return IGUIWindow.createFromHandle(IrrGUI_IGUIEnvironment_addWindow(handle,rectangle.handle,bModal,StringToWChar(text),parent.handle,id))
	EndMethod

	Method drawAll()
		IrrGUI_IGUIEnvironment_drawAll(handle)
	EndMethod
	
	Method getBuiltInFont:IGUIFont()
		' do not delete ptr
		Return IGUIFont.createFromHandle(IrrGUI_IGUIEnvironment_getBuiltInFont(handle),False)
	EndMethod

	Method getFont:IGUIFont(filename:String)
		' do not delete ptr
		Return IGUIFont.createFromHandle(IrrGUI_IGUIEnvironment_getFont(handle,filename),False)
	EndMethod

	Method getRootGUIElement:IGUIElement()
		Return IGUIElement.createFromHandle(IrrGUI_IGUIEnvironment_getRootGUIElement(handle))
	EndMethod
	
	Method getSkin:IGUISkin()
		Return IGUISkin.createFromHandle(IrrGUI_IGUIEnvironment_getSkin(handle))
	EndMethod
	
	Method setSkin(skin:IGUISkin)
		IrrGUI_IGUIEnvironment_setSkin(handle,skin.handle)
	EndMethod

	Method createSkin:IGUISkin(EGUI_SKIN_TYPE:Int)
		Return IGUISkin.createFromHandle(IrrGUI_IGUIEnvironment_createSkin(handle,EGUI_SKIN_TYPE))
	EndMethod
	
	Method getVideoDriver:IVideoDriver()
		Return IVideoDriver.createFromHandle(IrrGUI_IGUIEnvironment_getVideoDriver(handle),False)
	EndMethod

	Method hasFocus:Int(element:IGUIElement)
		Return IrrGUI_IGUIEnvironment_hasFocus(handle,element.handle)
	EndMethod
	
	Method postEventFromUser:Int(ev:SEvent)
		Return IrrGUI_IGUIEnvironment_postEventFromUser(handle,ev.handle)
	EndMethod
	
	Method removeFocus(element:IGUIElement)
		IrrGUI_IGUIEnvironment_removeFocus(handle,element.handle)
	EndMethod 
	
	Method setFocus(element:IGUIElement)
		IrrGUI_IGUIEnvironment_setFocus(handle,element.handle)
	EndMethod

	Method setUserEventReceiver(rec:IEventReceiver)
		IrrGUI_IGUIEnvironment_setUserEventReceiver(handle,rec.handle)
	EndMethod

	Method getFocus:IGUIElement()
		Return IGUIElement.createFromHandle(IrrGUI_IGUIEnvironment_getFocus(handle),False)
	EndMethod
	
	Method getFileSystem:IFileSystem()
		Return IFileSystem.createFromHandle(IrrGUI_IGUIEnvironment_getFileSystem(handle),False)
	EndMethod
	
	Method clear()
		IrrGUI_IGUIEnvironment_clear(handle)
	EndMethod
	
	Method getSpriteBank:IGUISpriteBank(filename:String)
		Return IGUISpriteBank.createFromHandle(IrrGUI_IGUIEnvironment_getSpriteBank(handle,filename),True)
	EndMethod
	
	Method addEmptySpriteBank:IGUISpriteBank(name:String)
		Return IGUISpriteBank.createFromHandle(IrrGUI_IGUIEnvironment_addEmptySpriteBank(handle,name),True)
	EndMethod
	
	Method addModalScreen:IGUIElement(parent:IGUIelement=Null)
		If Not parent Or Not parent.IsValid() Then parent=new IGUIElement
		Return IGUIElement.createFromHandle(IrrGUI_IGUIEnvironment_addModalScreen(handle,parent.handle),True)
	EndMethod
	
	Method getDefaultGUIElementFactory:IGUIElementFactory()
		Return IGUIElementFactory.createFromHandle(IrrGUI_IGUIEnvironment_getDefaultGUIElementFactory(handle),False)
	EndMethod
	
	Method registerGUIElementFactory(factory:IGUIElementFactory)
		IrrGUI_IGUIEnvironment_registerGUIElementFactory(handle,factory.handle)
	EndMethod
	
	Method getRegisteredGUIElementFactoryCount:Int()
		Return IrrGUI_IGUIEnvironment_getRegisteredGUIElementFactoryCount:Int(handle)
	EndMethod
	
	Method getGUIElementFactory:IGUIElementFactory(index:Int)
		Return IGUIElementFactory.createFromHandle(IrrGUI_IGUIEnvironment_getGUIElementFactory(handle,index),False)
	EndMethod
	
	Method addGUIElement:IGUIElement(elementName:String,parent:IGUIElement=Null)
		If Not parent Or Not parent.IsValid() Then parent=new IGUIElement
		Return IGUIElement.createFromHandle(IrrGUI_IGUIEnvironment_addGUIElement(handle,elementName,parent.handle))
	EndMethod
		
	Method serializeAttributes(out:IAttributes,options:SAttributeReadWriteOptions=Null)
		If Not options Or Not options.IsValid() Then options=New SAttributeReadWriteOptions
		IrrGUI_IGUIEnvironment_serializeAttributes(handle,out.handle,options.handle)
	EndMethod
	
	Method deserializeAttributes(in:IAttributes,options:SAttributeReadWriteOptions=Null)
		If Not options Or Not options.IsValid() Then options=New SAttributeReadWriteOptions
		IrrGUI_IGUIEnvironment_deserializeAttributes(handle,in.handle,options.handle)
	EndMethod
	
	Method writeGUIElement(writer:IXMLWriter,node:IGUIElement)
		IrrGUI_IGUIEnvironment_writeGUIElement(handle,writer.handle,node.handle)
	EndMethod
	
	Method readGUIElement(reader:IXMLReader,parent:IGUIElement)
		IrrGUI_IGUIEnvironment_readGUIElement(handle,reader.handle,parent.handle) 
	EndMethod
	
	Method getOSOperator:IOSOperator()
		Return IOSOperator.createFromHandle(IrrGUI_IGUIEnvironment_getOSOperator(handle),False)
	EndMethod

	Method saveGUI:Int(filename:String,start:IGUIElement=Null)
		Return IrrGUI_IGUIEnvironment_saveGUI(handle,filename,_HANDLE(start))
	EndMethod
	
	Method saveGUIToFileIO:Int(file:IWriteFile,start:IGUIElement=Null)
		Return IrrGUI_IGUIEnvironment_saveGUIToFileIO(handle,file.handle,_HANDLE(start))
	EndMethod
	
	Method loadGUI:Int(filename:String,parent:IGUIElement=Null)
		Return IrrGUI_IGUIEnvironment_loadGUI(handle,filename,_HANDLE(parent))
	EndMethod
	
	Method loadGUIFromFileIO:Int(file:IReadFile,parent:IGUIElement=Null)
		Return IrrGUI_IGUIEnvironment_loadGUIFromFileIO(handle,file.handle,_HANDLE(parent))
	EndMethod

	Method addSpinBox:IGUISpinBox(text:String, rectangle:Recti, parent:IGUIElement = Null, id:Int = -1)
		Return IGUISpinBox.createFromHandle(IrrGUI_IGUIEnvironment_addSpinBox(handle, StringToWChar(text), rectangle.handle, _HANDLE(parent), id), True)
	EndMethod

	Method addTable:IGUITable(rectangle:Recti, parent:IGUIElement = Null, id:Int = -1, bDrawBackground:Int = False)
		Return IGUITable.createFromHandle(IrrGUI_IGUIEnvironment_addTable(handle, _HANDLE(rectangle), _HANDLE(parent), id, bDrawBackground))
	EndMethod
	
EndType
