' ------------------------------------------------------------------------------------
' irr::io::IFileSystem wrappers
' use irr:IrrlichtDevice.getFileSystem() To get a pointer For this.  do Not Delete
' Or drop.
' ------------------------------------------------------------------------------------
Public

Type IFileSystem Extends IReferenceCounted Final

	Function createFromHandle:IFileSystem(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IFileSystem=New IFileSystem
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method createEmptyAttributes:IAttributes(driver:IVideoDriver=Null)
		If Not driver Then driver=new IVideoDriver ' default handle to 0
		Local att:Int=IrrIO_IFileSystem_createEmptyAttributes(handle,driver.handle)
		If att>0 Then Return IAttributes.createFromHandle(att,True) Else Return Null
	EndMethod

	Method addPakFileArchive:Int(filename:String,bIgnoreCase:Int=True,bIgnorePaths:Int=True)
		Return IrrIO_IFileSystem_addPakFileArchive(handle,filename,bIgnoreCase,bIgnorePaths)
	EndMethod
	
	Method addZipFileArchive:Int(filename:String,bIgnoreCase:Int=True,bIgnorePaths:Int=True)
		Return IrrIO_IFileSystem_addZipFileArchive(handle,filename,bIgnoreCase,bIgnorePaths)
	EndMethod
	
	Method changeWorkingDirectoryTo:Int(newDirectory:String)
		Return IrrIO_IFileSystem_changeWorkingDirectoryTo(handle,newDirectory)
	EndMethod

	Method createAndOpenFile:IReadFile(filename:String)
		' returned pointer must be dropped IReadFile*
		Return IReadFile.createFromHandle(IrrIO_IFileSystem_createAndOpenFile(handle,filename))
	EndMethod

	Method createAndWriteFile:IWriteFile(filename:String,bAppend:Int=False)
		' returned pointer must be dropped IWriteFile*
		Return IWriteFile.createFromHandle(IrrIO_IFileSystem_createAndWriteFile(handle,filename,bAppend))
	EndMethod 

	Method createFileList:IFileList()
		' returned pointer must be dropped IFileList*
		Return IFileList.createFromHandle(IrrIO_IFileSystem_createFileList(handle))
	EndMethod
	
	Method createXMLReaderFromStream:IXMLReader(read:IReadFile)
		' returned pointer must be dropped IXMLReader*
		Return IXMLReader.createFromHandle(IrrIO_IFileSystem_createXMLReaderFromStream(handle,read.handle))
	EndMethod

	Method createXMLReader:IXMLReader(filename:String)
		' returned pointer must be dropped IXMLReader*
		Return IXMLReader.createFromHandle(IrrIO_IFileSystem_createXMLReader(handle,filename))
	EndMethod

	Method createXMLReaderUTF8FromStream:IXMLReaderUTF8(read:IReadFile)
		' returned pointer must be dropped IXMLReaderUTF8*
		Return IXMLReaderUTF8.createFromHandle(IrrIO_IFileSystem_createXMLReaderUTF8FromStream(handle,read.handle))
	EndMethod

	Method createXMLReaderUTF8:IXMLReaderUTF8(filename:String)
		' returned pointer must be dropped IXMLReaderUTF8*
		Return IXMLReaderUTF8.createFromHandle(IrrIO_IFileSystem_createXMLReaderUTF8(handle,filename))
	EndMethod

	Method createXMLWriterFromStream:IXMLWriter(write:IWriteFile)
		' returned pointer must be dropped IXMLWriter*
		Return IXMLWriter.createFromHandle(IrrIO_IFileSystem_createXMLWriterFromStream(handle,write.handle))
	EndMethod

	Method createXMLWriter:IXMLWriter(filename:String)
		' returned pointer must be dropped IXMLWriter*
		Return IXMLWriter.createFromHandle(IrrIO_IFileSystem_createXMLWriter(handle,filename))
	EndMethod
	
	Method existFile:Int(filename:String)
		Return IrrIO_IFileSystem_existFile(handle,filename)
	EndMethod
	
	Method getWorkingDirectory:String()
		Return IrrIO_IFileSystem_getWorkingDirectory(handle)
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrIO_IFileSystem_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrIO_IFileSystem_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrIO_IFileSystem_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod

	Method addFolderFileArchive:Int(filename:String,bIgnoreCase:Int=true,bIgnorePaths:Int=true)
		Return IrrIO_IFileSystem_addFolderFileArchive(handle,filename,bIgnoreCase,bIgnorePaths)
	EndMethod
	
	Method getAbsolutePath:String(filename:String)
		Return IrrIO_IFileSystem_getAbsolutePath(handle,filename)
	EndMethod

	Method getFileDir:String(filename:String)
		Return IrrIO_IFileSystem_getFileDir(handle,filename)
	EndMethod

	Method createMemoryReadFile:IReadFile(memory:Byte Ptr,length:Int,fileName:String,bDeleteMemoryWhenDropped:Int=False)
		Return IReadFile.createFromHandle(IrrIO_IFileSystem_createMemoryReadFile(handle,memory,length,fileName,bDeleteMemoryWhenDropped),True)
	EndMethod

	Method getFileBasename:String(filename:String, bKeepExtension:Int = True)
		Return IrrIO_IFileSystem_getFileBasename(handle, filename, bKeepExtension)
	EndMethod
	
EndType


