//------------------------------------------------------------------------------------
// irr::io::IFileSystem wrappers
// use irr:IrrlichtDevice.getFileSystem() to get a pointer for this.  do not delete
// or drop.
//------------------------------------------------------------------------------------

extern "C"
{
	
	IAttributes* IrrIO_IFileSystem_createEmptyAttributes(IFileSystem* file,video::IVideoDriver* driver=0)
	{
		if (file)
			return file->createEmptyAttributes(driver);
		else return 0;
	}
	
	bool IrrIO_IFileSystem_addZipFileArchive(IFileSystem* file,const c8 *filename,bool ignoreCase=true,bool ignorePaths=true)
	{
		if (file)
			return file->addZipFileArchive(filename,ignoreCase,ignorePaths);
		else
			return false;
	}
	
	bool IrrIO_IFileSystem_addPakFileArchive(IFileSystem* file,const c8 *filename,bool ignoreCase=true,bool ignorePaths=true)
	{
		if (file)
			return file->addPakFileArchive(filename,ignoreCase,ignorePaths);
		else
			return false;
	}

	bool IrrIO_IFileSystem_changeWorkingDirectoryTo(IFileSystem* file,const c8 *newDirectory)
	{
		if (file)
			return file->changeWorkingDirectoryTo(newDirectory);
		else
			return false;
	}
	
	// this pointer must be dropped
	IReadFile* IrrIO_IFileSystem_createAndOpenFile(IFileSystem* file,const c8 *filename)
	{
		if (file)
			return file->createAndOpenFile(filename);
		else
			return 0;
	}
	
	// this pointer must be dropped
	IWriteFile* IrrIO_IFileSystem_createAndWriteFile(IFileSystem* file,const c8 *filename,bool append=false)
	{
		if (file)
			return file->createAndWriteFile(filename,append);
		else
			return 0;
	}
	
	// this pointer must be dropped
	IFileList* IrrIO_IFileSystem_createFileList(IFileSystem* file)
	{
		if (file)
			return file->createFileList();
		else
			return 0;
	}
	
	// this pointer must be dropped
	IXMLReader* IrrIO_IFileSystem_createXMLReaderFromStream(IFileSystem* file,IReadFile* filestream)
	{
		if (file)
			return file->createXMLReader(filestream);
		else
			return 0;
	}
	
	// this pointer must be dropped
	IXMLReader* IrrIO_IFileSystem_createXMLReader(IFileSystem* file,const c8 *filename)
	{
		if (file)
			return file->createXMLReader(filename);
		else
			return 0;
	}
	
	// this pointer must be dropped
	IXMLReaderUTF8* IrrIO_IFileSystem_createXMLReaderUTF8FromStream(IFileSystem* file,IReadFile* filestream)
	{
		if (file)
			return file->createXMLReaderUTF8(filestream);
		else
			return 0;
	}
	
	// this pointer must be dropped
	IXMLReaderUTF8* IrrIO_IFileSystem_createXMLReaderUTF8(IFileSystem* file,const c8 *filename)
	{
		if (file)
			return file->createXMLReaderUTF8(filename);
		else
			return 0;
	}
	
	// this pointer must be dropped
	IXMLWriter* IrrIO_IFileSystem_createXMLWriterFromStream(IFileSystem* file,IWriteFile* filestream)
	{
		if (file)
			return file->createXMLWriter(filestream);
		else
			return 0;
	}
	
	// this pointer must be dropped
	IXMLWriter* IrrIO_IFileSystem_createXMLWriter(IFileSystem* file,const c8 *filename)
	{
		if (file)
			return file->createXMLWriter(filename);
		else
			return 0;
	}
	
	bool IrrIO_IFileSystem_existFile(IFileSystem* file,const c8 *filename)
	{
		if (file)
			return file->existFile(filename);
		else
			return false;
	}
	
	const c8* IrrIO_IFileSystem_getWorkingDirectory(IFileSystem* file)
	{
		if (file)
			return file->getWorkingDirectory();
		else
			return "";
	}

	bool IrrIO_IFileSystem_drop(IFileSystem* unk)
	{
		if (unk)
			return unk->drop();
		else return 0;
	}
	
	const c8* IrrIO_IFileSystem_getDebugName(IFileSystem* unk)
	{
		if (unk)
			return unk->getDebugName();
		else return "";
	}
	
	void IrrIO_IFileSystem_grab(IFileSystem* unk)
	{
		if (unk)
			unk->grab();
	}
	
	bool IrrIO_IFileSystem_addFolderFileArchive(IFileSystem* file,const c8* filename, bool ignoreCase = true, bool ignorePaths = true)
	{
		if (file)
			return file->addFolderFileArchive(filename,ignoreCase,ignorePaths);
		else return false;
	}
	
	const c8* IrrIO_IFileSystem_getAbsolutePath(IFileSystem* file,const c8 *filename)
	{
		if (file) {
			stringc fname=stringc(filename);
			return file->getAbsolutePath(fname).c_str();
		} else return 0;
	}

	const c8* IrrIO_IFileSystem_getFileDir(IFileSystem* file,const c8 *filename)
	{
		if (file) {
			stringc fname=stringc(filename);
			return file->getFileDir(fname).c_str();
		} else return 0;
	}
	
	IReadFile* IrrIO_IFileSystem_createMemoryReadFile(IFileSystem* file,void* memory, s32 len, const c8* fileName, bool deleteMemoryWhenDropped=false)
	{
		if (file) {
			return file->createMemoryReadFile(memory,len,fileName,deleteMemoryWhenDropped);
		} else return 0;	
	}
	
	const c8* IrrIO_IFileSystem_getFileBasename(IFileSystem* file, const c8* filename, bool keepExtension=true)
	{
		if (file) {
			stringc fname = stringc(filename);
			return file->getFileBasename(fname, keepExtension).c_str();
		} else return 0;
	}	
}
