' ------------------------------------------------------------------------------------
' irr::io::IWriteFile wrappers
' be sure To call the drop Function when done
' ------------------------------------------------------------------------------------
' 2005/11/28 - implemented fix for write() from Doug Stastny (Budman)
'

Public

Type IWriteFile Extends IReferenceCounted Final

	Function createFromHandle:IWriteFile(pHandle:Int,bMustDel:Int=True)
		If Not pHandle Then Return Null
		Local oRetVal:IWriteFile=New IWriteFile
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method getFileName:String()
		Return String.FromCString(IrrIO_IWriteFile_getFileName(handle))
	EndMethod
	
	Method getPos:Long()
		Return IrrIO_IWriteFile_getPos(handle)
	EndMethod
	
	Method seek:Int(finalPos:Long,bRelativeMovement:Int=False)
		Return IrrIO_IWriteFile_seek(handle,finalPos,bRelativeMovement)
	EndMethod
	
	Method write:Int(buffer:Byte Ptr,sizeToWrite:Int)
		Return IrrIO_IWriteFile_write(handle,buffer,sizeToWrite)
	EndMethod
	
	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrIO_IWriteFile_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrIO_IWriteFile_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrIO_IWriteFile_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
EndType
