' ------------------------------------------------------------------------------------
' irr::ILogger wrappers
'------------------------------------------------------------------------------------

Public

Type ILogger Extends IReferenceCounted Final

	Function createFromHandle:ILogger(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:ILogger=New ILogger
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method getLogLevel:Int() ' returns ELOG_LEVEL
		Return Irr_ILogger_getLogLevel(handle)
	EndMethod
	
	Method setLogLevel(ELOG_LEVEL:Int)
		Irr_ILogger_setLogLevel(handle,ELOG_LEVEL:Int)
	EndMethod

	Method log(text:String,loglevel:Int=ELL_INFORMATION)
		Irr_ILogger_logC(handle,text,loglevel)
	EndMethod
	
	Method logWithHint(text:String,hint:String,loglevel:Int=ELL_INFORMATION)
		Irr_ILogger_logCWithHint(handle,text,hint,loglevel)
	EndMethod
	
	Method logC(text:String,loglevel:Int=ELL_INFORMATION)
		Irr_ILogger_logC(handle,text,loglevel)
	EndMethod
	
	Method logCWithHint(text:String,hint:String,loglevel:Int=ELL_INFORMATION)
		Irr_ILogger_logCWithHint(handle,text,hint,loglevel)
	EndMethod
	
	Method logW(text:String,loglevel:Int=ELL_INFORMATION)
		Irr_ILogger_logW(handle,text,loglevel)
	EndMethod
	
	Method logWWithHint(text:String,hint:String,loglevel:Int=ELL_INFORMATION)
		Irr_ILogger_logWWithHint(handle,text,hint,loglevel)
	EndMethod
	
	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return Irr_ILogger_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return Irr_ILogger_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		Irr_ILogger_grab(handle)
	EndMethod
	
	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
EndType
