Public

'enum eMD3Models
Const EMD3_HEAD:Int = 0
Const EMD3_UPPER:Int = 1
Const EMD3_LOWER:Int = 2
Const EMD3_WEAPON:Int = 3
Const EMD3_NUMMODELS:Int = 4

' Animation list
'enum EMD3_ANIMATION_TYPE

' Animations for both lower and upper parts of the player
Const EMD3_BOTH_DEATH_1:Int = 0
Const EMD3_BOTH_DEAD_1:Int = 1
Const EMD3_BOTH_DEATH_2:Int = 2
Const EMD3_BOTH_DEAD_2:Int = 3
Const EMD3_BOTH_DEATH_3:Int = 4
Const EMD3_BOTH_DEAD_3:Int = 5

' Animations for the upper part
Const EMD3_TORSO_GESTURE:Int = 6
Const EMD3_TORSO_ATTACK_1:Int = 7
Const EMD3_TORSO_ATTACK_2:Int = 8
Const EMD3_TORSO_DROP:Int = 9
Const EMD3_TORSO_RAISE:Int = 10
Const EMD3_TORSO_STAND_1:Int = 11
Const EMD3_TORSO_STAND_2:Int = 12

' Animations for the lower part
Const EMD3_LEGS_WALK_CROUCH:Int = 13
Const EMD3_LEGS_WALK:Int = 14
Const EMD3_LEGS_RUN:Int = 15
Const EMD3_LEGS_BACK:Int = 16
Const EMD3_LEGS_SWIM:Int = 17
Const EMD3_LEGS_JUMP_1:Int = 18
Const EMD3_LEGS_LAND_1:Int = 19
Const EMD3_LEGS_JUMP_2:Int = 20
Const EMD3_LEGS_LAND_2:Int = 21
Const EMD3_LEGS_IDLE:Int = 22
Const EMD3_LEGS_IDLE_CROUCH:Int = 23
Const EMD3_LEGS_TURN:Int = 24

'! Not an animation, but amount of animation types.
Const EMD3_ANIMATION_COUNT:Int = 25

'  -------------------------------------------------------------------------
'  SMD3AnimationInfo
'  -------------------------------------------------------------------------
Type SMD3AnimationInfo Extends IrrBase Final

	Function createFromHandle:SMD3AnimationInfo(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMD3AnimationInfo=New SMD3AnimationInfo
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method getFirst:Int()
		Return IrrScene_SMD3AnimationInfo_getFirst(handle)
	EndMethod
	
	Method setFirst(first:Int)
		IrrScene_SMD3AnimationInfo_setFirst(handle,first)
	EndMethod
	
	Method getNum:Int()
		Return IrrScene_SMD3AnimationInfo_getNum(handle)
	EndMethod
	
	Method setNum(num:Int)
		IrrScene_SMD3AnimationInfo_setNum(handle,num)
	EndMethod
	
	Method getLooping:Int()
		Return IrrScene_SMD3AnimationInfo_getLooping(handle)
	EndMethod
	
	Method setLooping(looping:Int)
		IrrScene_SMD3AnimationInfo_setLooping(handle,looping)
	EndMethod
	
	Method getFPS:Int()
		Return IrrScene_SMD3AnimationInfo_getFPS(handle)
	EndMethod
	
	Method setFPS(fps:Int)
		IrrScene_SMD3AnimationInfo_setFPS(handle,fps)
	EndMethod

EndType

'  -------------------------------------------------------------------------
'  SMD3Header
'  -------------------------------------------------------------------------
Type SMD3Header Extends IrrBase Final

	Function createFromHandle:SMD3Header(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMD3Header=New SMD3Header
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method getHeaderID:String()
		Return IrrScene_SMD3Header_getHeaderID(handle)
	EndMethod
	
	Method getVersion:Int()
		Return IrrScene_SMD3Header_getVersion(handle)
	EndMethod
	
	Method getFileName:String()
		Return IrrScene_SMD3Header_getFileName(handle)
	EndMethod
	
	Method getNumFrames:Int()
		Return IrrScene_SMD3Header_getNumFrames(handle)
	EndMethod
	
	Method getNumTags:Int()
		Return IrrScene_SMD3Header_getNumTags(handle)
	EndMethod
	
	Method getNumMeshes:Int()
		Return IrrScene_SMD3Header_getNumMeshes(handle)
	EndMethod
	
	Method getNumMaxSkins:Int()
		Return IrrScene_SMD3Header_getNumMaxSkins(handle)
	EndMethod
	
	Method getHeaderSize:Int()
		Return IrrScene_SMD3Header_getHeaderSize(handle)
	EndMethod
	
	Method getTagStart:Int()
		Return IrrScene_SMD3Header_getTagStart(handle)
	EndMethod
	
	Method getTagEnd:Int()
		Return IrrScene_SMD3Header_getTagEnd(handle)
	EndMethod
	
	Method getFileSize:Int()
		Return IrrScene_SMD3Header_getFileSize(handle)
	EndMethod

EndType

'  -------------------------------------------------------------------------
'  SMD3MeshHeader
'  -------------------------------------------------------------------------
Type SMD3MeshHeader Extends IrrBase Final

	Function createFromHandle:SMD3MeshHeader(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMD3MeshHeader=New SMD3MeshHeader
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method getMeshID:String()
		Return IrrScene_SMD3MeshHeader_getMeshID(handle)
	EndMethod
	
	Method getMeshName:String()
		Return IrrScene_SMD3MeshHeader_getMeshName(handle)
	EndMethod
	
	Method getNumFrames:Int()
		Return IrrScene_SMD3MeshHeader_getNumFrames(handle)
	EndMethod
	
	Method getNumShader:Int()
		Return IrrScene_SMD3MeshHeader_getNumShader(handle)
	EndMethod
	
	Method getNumVertices:Int()
		Return IrrScene_SMD3MeshHeader_getNumVertices(handle)
	EndMethod
	
	Method getNumTriangles:Int()
		Return IrrScene_SMD3MeshHeader_getNumTriangles(handle)
	EndMethod
	
	Method getOffset_Triangles:Int()
		Return IrrScene_SMD3MeshHeader_getOffset_Triangles(handle)
	EndMethod
	
	Method getOffset_Shaders:Int()
		Return IrrScene_SMD3MeshHeader_getOffset_Shaders(handle)
	EndMethod
	
	Method getOffset_St:Int()
		Return IrrScene_SMD3MeshHeader_getOffset_St(handle)
	EndMethod
	
	Method getVertexStart:Int()
		Return IrrScene_SMD3MeshHeader_getVertexStart(handle)
	EndMethod
	
	Method getOffset_End:Int()
		Return IrrScene_SMD3MeshHeader_getOffset_End(handle)
	EndMethod

EndType

'  -------------------------------------------------------------------------
'  SMD3Vertex
'  -------------------------------------------------------------------------
Type SMD3Vertex Extends IrrBase Final

	Function createFromHandle:SMD3Vertex(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMD3Vertex=New SMD3Vertex
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getPosition:Short Ptr()
		Return IrrScene_SMD3Vertex_getPosition(handle) ' returns array size 3
	EndMethod
	
	Method getNormal:Byte Ptr()
		Return IrrScene_SMD3Vertex_getNormal(handle) ' returns array size 2
	EndMethod
	
EndType

'  -------------------------------------------------------------------------
'  SMD3TexCoord
'  -------------------------------------------------------------------------
Type SMD3TexCoord Extends IrrBase Final

	Function createFromHandle:SMD3TexCoord(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMD3TexCoord=New SMD3TexCoord
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method getU:Float()
		Return IrrScene_SMD3TexCoord_getU(handle)
	EndMethod
	
	Method getV:Float()
		Return IrrScene_SMD3TexCoord_getV(handle)
	EndMethod

EndType

'  -------------------------------------------------------------------------
'  SMD3Face
'  -------------------------------------------------------------------------
Type SMD3Face Extends IrrBase Final

	Function createFromHandle:SMD3Face(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMD3Face=New SMD3Face
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method getIndex:Int Ptr()
		Return IrrScene_SMD3Face_getIndex(handle) ' returns array size 3
	EndMethod
	
EndType

'  -------------------------------------------------------------------------
'  SMD3MeshBuffer IUnknown
'  -------------------------------------------------------------------------
Type SMD3MeshBuffer Extends IReferenceCounted Final

	Function createFromHandle:SMD3MeshBuffer(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMD3MeshBuffer=New SMD3MeshBuffer
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_SMD3MeshBuffer_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_SMD3MeshBuffer_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_SMD3MeshBuffer_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
	
	'  do not delete
	Method getMeshHeader:SMD3MeshHeader()
		Return SMD3MeshHeader.createFromHandle(IrrScene_SMD3MeshBuffer_getMeshHeader(handle),False)
	EndMethod
	
	Method getShaders:String[]()

		Local shader_ptr:Int Ptr	
		Local shaders:String[]=Null				

		Local size:Int=IrrScene_SMD3MeshBuffer_getShaders(handle,Varptr(shader_ptr))
		
		If size>0 Then		
			shaders=New String[size]

			For Local i:Int=0 Until size
				shaders[i]=String.FromCString(Byte Ptr(shader_ptr[i]))
			Next
		EndIf
		
		Irr_ptrarray_delete(Varptr(shader_ptr))
		
		Return shaders
	EndMethod

	Method getVertices:SMD3Vertex[]()
		Local ptrs:Int Ptr	
		Local vertices:SMD3Vertex[]=Null				

		Local size:Int=IrrScene_SMD3MeshBuffer_getVertices(handle,Varptr(ptrs))
		If size>0 Then		
			vertices=New SMD3Vertex[size]

			For Local i:Int=0 Until size
				vertices[i]=SMD3Vertex.createFromHandle(ptrs[i],False)
			Next
		EndIf
		
		Irr_ptrarray_delete(Varptr(ptrs))
		
		Return vertices	
	EndMethod

	Method getTexCoords:SMD3TexCoord[]()
		Local ptrs:Int Ptr	
		Local objs:SMD3TexCoord[]=Null				

		Local size:Int=IrrScene_SMD3MeshBuffer_getTexCoords(handle,Varptr(ptrs))
		If size>0 Then		
			objs=New SMD3TexCoord[size]

			For Local i:Int=0 Until size
				objs[i]=SMD3TexCoord.createFromHandle(ptrs[i],False)
			Next
		EndIf
		
		Irr_ptrarray_delete(Varptr(ptrs))
		
		Return objs
	EndMethod
	
	Method getIndices:Int[]()
		Local ptrs:Int Ptr	
		Local objs:Int[]=Null				

		Local size:Int=IrrScene_SMD3MeshBuffer_getIndices(handle,Varptr(ptrs))
		If size>0 Then		
			objs=New Int[size]

			For Local i:Int=0 Until size
				objs[i]=ptrs[i]
			Next
		EndIf
		
		Irr_ptrarray_delete(Varptr(ptrs))
		
		Return objs		
	EndMethod
EndType

'  -------------------------------------------------------------------------
'  SMD3QuaternionTag
'  -------------------------------------------------------------------------
Type SMD3QuaternionTag Extends IrrBase Final

	Function createFromHandle:SMD3QuaternionTag(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMD3QuaternionTag=New SMD3QuaternionTag
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method setto(m:Matrix4)
		IrrScene_SMD3QuaternionTag_setto(handle,m.handle)
	EndMethod
	
	Method getName:String()
		Return IrrScene_SMD3QuaternionTag_getName(handle)
	EndMethod
	
	Method getPosition:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_SMD3QuaternionTag_getPosition(handle),False)
	EndMethod
	
	Method getRotation:Quaternion()
		Return Quaternion.createFromHandle(IrrScene_SMD3QuaternionTag_getRotation(handle),False)
	EndMethod
	
	Method EqEq:Int(other:SMD3QuaternionTag) 
		Return IrrScene_SMD3QuaternionTag_EqEq(handle, other.handle)
	EndMethod
EndType

'  -------------------------------------------------------------------------
'  SMD3QuaternionTagList IUnknown
'  -------------------------------------------------------------------------
Type SMD3QuaternionTagList Extends IReferenceCounted Final

	Function createFromHandle:SMD3QuaternionTagList(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMD3QuaternionTagList=New SMD3QuaternionTagList
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_SMD3QuaternionTagList_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_SMD3QuaternionTagList_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_SMD3QuaternionTagList_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod

	Method get:SMD3QuaternionTag(name:String)
		Return SMD3QuaternionTag.createFromHandle(IrrScene_SMD3QuaternionTagList_get(handle,name),False)
	EndMethod
	
	Method getSize:Int()
		Return IrrScene_SMD3QuaternionTagList_getSize(handle)
	EndMethod
	
	Method Index:SMD3QuaternionTag(index:Int)
		Return SMD3QuaternionTag.createFromHandle(IrrScene_SMD3QuaternionTagList_Index(handle,index),False)
	EndMethod

	Method setEq:SMD3QuaternionTagList(copyMe:SMD3QuaternionTagList)
		IrrScene_SMD3QuaternionTagList_setEq(handle, copyMe.handle)
		Return Self
	EndMethod
	
	Method getContainer:SMD3QuaternionTag[]()
		Local ptrs:Int Ptr	
		Local objs:SMD3QuaternionTag[]=Null				

		Local size:Int=IrrScene_SMD3QuaternionTagList_getContainer(handle,Varptr(ptrs))
		If size>0 Then		
			objs=New SMD3QuaternionTag[size]

			For Local i:Int=0 Until size
				objs[i]=SMD3QuaternionTag.createFromHandle(ptrs[i],False)
			Next
		EndIf
		
		Irr_ptrarray_delete(Varptr(ptrs))
		
		Return objs		
	EndMethod

EndType

' -------------------------------------------------------------------------
' SMD3Mesh IUnknown
' -------------------------------------------------------------------------
Type SMD3Mesh Extends IReferenceCounted Final

	Function createFromHandle:SMD3Mesh(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SMD3Mesh=New SMD3Mesh
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_SMD3Mesh_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_SMD3Mesh_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_SMD3Mesh_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
	
	Method getMD3Header:SMD3Header()
		Return SMD3Header.createFromHandle(IrrScene_SMD3Mesh_getMD3Header(handle),False)
	EndMethod

	Method getName:String()
		Return IrrScene_SMD3Mesh_getName(handle)
	EndMethod
	
	'  do not delete
	Method getBuffer:SMD3MeshBuffer[]()
		Local ptrs:Int Ptr	
		Local objs:SMD3MeshBuffer[]=Null				

		Local size:Int=IrrScene_SMD3Mesh_getBuffer(handle,Varptr(ptrs))
		If size>0 Then		
			objs=New SMD3MeshBuffer[size]

			For Local i:Int=0 Until size
				objs[i]=SMD3MeshBuffer.createFromHandle(ptrs[i],False)
			Next
		EndIf
		
		Irr_ptrarray_delete(Varptr(ptrs))
		
		Return objs				
	EndMethod
	
	Method getTagList:SMD3QuaternionTagList()
		Return SMD3QuaternionTagList.createFromHandle(IrrScene_SMD3Mesh_getTagList(handle),False)
	EndMethod
EndType


'  -------------------------------------------------------------------------
'  IAnimatedMeshMD3 IAnimatedMesh
'  -------------------------------------------------------------------------
Type IAnimatedMeshMD3 Extends IAnimatedMesh Final

	Function createFromHandle:IAnimatedMeshMD3(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:IAnimatedMeshMD3=New IAnimatedMeshMD3
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Method setInterpolationShift(shift:Int,loopMode:Int)
		IrrScene_IAnimatedMeshMD3_setInterpolationShift(handle,shift,loopMode)
	EndMethod
	
	Method getTagList:SMD3QuaternionTagList(frame:Int,detailLevel:Int,startFrameLoop:Int,endFrameLoop:Int)
		Return SMD3QuaternionTagList.createFromHandle(IrrScene_IAnimatedMeshMD3_getTagList(handle,frame,detailLevel,startFrameLoop,endFrameLoop),False)
	EndMethod
	
	Method getOriginalMesh:SMD3Mesh()
		Return SMD3Mesh.createFromHandle(IrrScene_IAnimatedMeshMD3_getOriginalMesh(handle),False)
	EndMethod
EndType
