//------------------------------------------------------------------------------------
// irr::ICollisionCallback wrappers
//------------------------------------------------------------------------------------

class BMXICollisionCallback : public ICollisionCallback
{
public:

	BMXBinder binder;

	void (*BMXICollisionCallback_OnCollision)(s32 binding, ISceneNodeAnimatorCollisionResponse* animator, core::vector3df* newPosition);

	BMXBinder* getBinder()
	{
		return &binder;
	}

	BMXICollisionCallback() : ICollisionCallback()
	{
		BMXICollisionCallback_OnCollision = 0;
	}
	
	void bindOnCollision(void (*bind_OnCollision)(s32 binding, ISceneNodeAnimatorCollisionResponse* animator, core::vector3df* newPosition))
	{
		BMXICollisionCallback_OnCollision = bind_OnCollision;
	}

	virtual void OnCollision(ISceneNodeAnimatorCollisionResponse* animator, core::vector3df newPosition)
	{
		if (BMXICollisionCallback_OnCollision)
			BMXICollisionCallback_OnCollision(binder.binding, animator, &newPosition);
	}	
};

extern "C" 
{

	BMXICollisionCallback* IrrScene_BMXICollisionCallback_new()
	{
		return new BMXICollisionCallback();
	}
	
	BMXBinder* IrrScene_BMXICollisionCallback_getBinder(BMXICollisionCallback* collision_cb)
	{
		if (collision_cb)
			return collision_cb->getBinder();
		else return 0;
	}
	
	void IrrScene_BMXICollisionCallback_bindOnCollision(BMXICollisionCallback* collision_cb,void (*bind_OnCollision)(s32 binding, ISceneNodeAnimatorCollisionResponse* animator, core::vector3df* newPosition))
	{
		if (collision_cb)
			collision_cb->bindOnCollision(bind_OnCollision);
	}
	
	void IrrScene_BMXICollisionCallback_del(BMXICollisionCallback* del)
	{
		if (del)
			delete del;
			
		del=0;
	}

	bool IrrScene_ICollisionCallback_drop(ICollisionCallback* unk)
	{
		if (unk)
			return unk->drop();
		else return 0;
	}
	
	const c8* IrrScene_ICollisionCallback_getDebugName(ICollisionCallback* unk)
	{
		if (unk)
			return unk->getDebugName();
		else return "";
	}
	
	void IrrScene_ICollisionCallback_grab(ICollisionCallback* unk)
	{
		if (unk)
			unk->grab();
	}
	
}
