' ------------------------------------------------------------------------------------
' irr::scene::ILightSceneNode wrappers (parent is ISceneNode)
' ------------------------------------------------------------------------------------
Public

Type ILightSceneNode Extends ISceneNodeDefault Final

	Function createFromHandle:ILightSceneNode(pHandle:Int,bMustDel:Int=False,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:ILightSceneNode=New ILightSceneNode
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getLightData:SLight()
		' do not delete
		Return SLight.createFromHandle(IrrScene_ILightSceneNode_getLightData(handle),False)
	EndMethod

	Method setLightData(light:SLight)
		IrrScene_ILightSceneNode_setLightData(handle,light.handle)
	EndMethod

	Method setRadius(radius:Float)
		IrrScene_ILightSceneNode_setRadius(handle, radius)
	EndMethod
	
	Method getRadius:Float()
		Return IrrScene_ILightSceneNode_getRadius(handle)
	EndMethod
	
	Method setLightType(E_LIGHT_TYPE:Int)
		IrrScene_ILightSceneNode_setLightType(handle, E_LIGHT_TYPE)
	EndMethod
	
	Method getLightType:Int() ' returns E_LIGHT_TYPE
		Return IrrScene_ILightSceneNode_getLightType(handle) 
	EndMethod
	
	Method enableCastShadow(bShadow:Int = True)
		IrrScene_ILightSceneNode_enableCastShadow(handle, bShadow)
	EndMethod
	
	Method getCastShadow:Int()
		Return IrrScene_ILightSceneNode_getCastShadow(handle)
	EndMethod

EndType

