' ------------------------------------------------------------------------------------
' irr::scene::ISceneCollisionManager wrappers
' ------------------------------------------------------------------------------------
Public

Type ISceneCollisionManager Extends IReferenceCounted Final

	Function createFromHandle:ISceneCollisionManager(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:ISceneCollisionManager=New ISceneCollisionManager
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
	Method getCollisionPoint:Int(ray:Line3df,pselector:ITriangleSelector,outCollisionPoint:Vector3df,outTriangle:Triangle3df)
		Return IrrScene_ISceneCollisionManager_getCollisionPoint(handle,ray.handle,pselector.handle,outCollisionPoint.handle,outTriangle.handle)
	EndMethod

	' TODO: need to be sure to test these out values	
	Method getCollisionResultPosition:Vector3df(selector:ITriangleSelector,ellipsoidPosition:Vector3df,ellipsoidRadius:Vector3df,ellipsoidDirectionAndSpeed:Vector3df,triout:Triangle3df,bOutFalling:Int Ptr,slidingSpeed:Float=0.0005,gravityDirectionAndSpeed:Vector3df=Null)
		If gravityDirectionAndSpeed=Null Then gravityDirectionAndSpeed=New Vector3df ' default handle to 0
		Return Vector3df.createFromHandle(IrrScene_ISceneCollisionManager_getCollisionResultPosition(handle,selector.handle,ellipsoidPosition.handle,ellipsoidRadius.handle,ellipsoidDirectionAndSpeed.handle,triout.handle,bOutFalling,slidingSpeed,gravityDirectionAndSpeed.handle))
	EndMethod
	
	Method getRayFromScreenCoordinates:Line3df(pos:Position2di,camera:ICameraSceneNode=Null)
		If camera=Null Then camera=New ICameraSceneNode ' default handle to 0
		Local ray:Line3df=Line3df.createFromHandle(IrrScene_ISceneCollisionManager_getRayFromScreenCoordinates(handle,pos.handle,camera.handle))
		If ray And ray.IsValid() Then Return ray Else Return Null
	EndMethod
	
	Method getSceneNodeFromCameraBB:ISceneNode(camera:ICameraSceneNode,idBitMask:Int=0,bNoDebugObjects:Int=False)
		' do not delete
		Local node:ISceneNode=ISceneNode.createFromHandle(IrrScene_ISceneCollisionManager_getSceneNodeFromCameraBB(handle,camera.handle,idBitMask,bNoDebugObjects),False)
		If node And node.IsValid() Then Return node Else Return Null
	EndMethod
	
	Method getSceneNodeFromRayBB:ISceneNode(ray:Line3df,idBitMask:Int=0,bNoDebugObjects:Int=False)
		' do not delete
		Local node:ISceneNode=ISceneNode.createFromHandle(IrrScene_ISceneCollisionManager_getSceneNodeFromRayBB(handle,ray.handle,idBitMask,bNoDebugObjects),False)
		If node And node.IsValid() Then Return node Else Return Null
	EndMethod

	Method getSceneNodeFromScreenCoordinatesBB:ISceneNode(pos:Position2di,idBitMask:Int=0,bNoDebugObjects:Int=False)
		' do not delete
		Local node:ISceneNode=ISceneNode.createFromHandle(IrrScene_ISceneCollisionManager_getSceneNodeFromScreenCoordinatesBB(handle,pos.handle,idBitMask,bNoDebugObjects),False)
		If node And node.IsValid() Then Return node Else Return Null
	EndMethod

	Method getScreenCoordinatesFrom3DPosition:Position2di(pos:Vector3df,camera:ICameraSceneNode=Null)
		If camera=Null Then camera=New ICameraSceneNode ' default handle to 0
		Local coords:Position2di=Position2di.createFromHandle(IrrScene_ISceneCollisionManager_getScreenCoordinatesFrom3DPosition(handle,pos.handle,camera.handle))
		If coords And coords.IsValid() Then Return coords Else Return Null
	EndMethod

	Method drop:Int() Final
		If mustdelete Then mustdelete=False		
		Return IrrScene_ISceneCollisionManager_drop(handle)
	EndMethod
	
	Method getDebugName:String() Final
		Return IrrScene_ISceneCollisionManager_getDebugName(handle)
	EndMethod
	
	Method grab() Final
		IrrScene_ISceneCollisionManager_grab(handle)
	EndMethod

	Method Delete()
		If (mustdelete) Then drop()
	EndMethod
EndType


