' ------------------------------------------------------------------------------------
'  irr::scene::ISceneNodeAnimatorCollisionResponse wrappers (based on ISceneNodeAnimator)
' ------------------------------------------------------------------------------------
Public

Type ISceneNodeAnimatorCollisionResponse Extends ISceneNodeAnimator Final

	Function createFromHandle:ISceneNodeAnimatorCollisionResponse(pHandle:Int,bMustDel:Int=False,pGenFunc:Byte Ptr=Null)
		If Not pHandle Then Return Null
		Local oRetVal:ISceneNodeAnimatorCollisionResponse=New ISceneNodeAnimatorCollisionResponse
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
		
	Method getEllipsoidRadius:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_ISceneNodeAnimatorCollisionResponse_getEllipsoidRadius(handle))
	EndMethod
	
	Method getEllipsoidTranslation:Vector3df()	
		Return Vector3df.createFromHandle(IrrScene_ISceneNodeAnimatorCollisionResponse_getEllipsoidTranslation(handle))
	EndMethod
	
	Method getGravity:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_ISceneNodeAnimatorCollisionResponse_getGravity(handle))
	EndMethod
	
	Method getWorld:ITriangleSelector()
		'  do Not Delete this pointer
		Return ITriangleSelector.createFromHandle(IrrScene_ISceneNodeAnimatorCollisionResponse_getWorld(handle),False)
	EndMethod
	
	Method isFalling:Int()
		Return IrrScene_ISceneNodeAnimatorCollisionResponse_isFalling(handle)
	EndMethod
	
	Method setEllipsoidRadius(radius:Vector3df)
		IrrScene_ISceneNodeAnimatorCollisionResponse_setEllipsoidRadius(handle,radius.handle)
	EndMethod

	Method setEllipsoidTranslation(translation:Vector3df)
		IrrScene_ISceneNodeAnimatorCollisionResponse_setEllipsoidTranslation(handle,translation.handle)
	EndMethod
	
	Method setGravity(gravity:Vector3df)
		IrrScene_ISceneNodeAnimatorCollisionResponse_setGravity(handle,gravity.handle)
	EndMethod
	
	Method setWorld(newWorld:ITriangleSelector)
		IrrScene_ISceneNodeAnimatorCollisionResponse_setWorld(handle,newWorld.handle)
	EndMethod

	Method jump(jumpSpeed:Float)
		IrrScene_ISceneNodeAnimatorCollisionResponse_jump(handle, jumpSpeed) 
	EndMethod

EndType

