Public

Type ISceneUserDataSerializer Extends IrrBase

	Method OnReadUserData(forSceneNode:ISceneNode,userData:IAttributes) Abstract
	
	Method createUserData:IAttributes(forSceneNode:ISceneNode) Abstract

	'--------------------------------------------
	' binders
	'--------------------------------------------

	Method bind(rec:Int) Final
		Super.bind(rec)
		IrrScene_BMXISceneUserDataSerializer_bindOnReadUserData( ..
			translate(rec).handle, ..
			OnReadUserDataBinding)
		IrrScene_BMXISceneUserDataSerializer_bindCreateUserData( ..
			translate(rec).handle, ..
			CreateUserDataBinding)
	EndMethod

	Function CreateUserDataBinding:Int(binding:Int,pISceneNode_forSceneNode:Int)
		' get the object whose node is firing
		Local tempobj:ISceneUserDataSerializer=ISceneUserDataSerializer(translate(binding))
		
		If tempobj<>Null
	  		' get the node
  			Local tempnode:ISceneNode=ISceneNode.createFromHandle(pISceneNode_forSceneNode,False)
  			' fire the event
	  		Local retval:IAttributes=tempobj.createUserData(tempnode)
	  		If Not retval Or Not retval.IsValid() Then Return 0 Else Return retval.handle
		Else
			Throw "Unable to find bound object"
		EndIf
	EndFunction

	Function OnReadUserDataBinding(binding:Int,pISceneNode_forSceneNode:Int,pIAttributes_userData:Int)
		' get the object whose node is firing
		Local tempobj:ISceneUserDataSerializer=ISceneUserDataSerializer(translate(binding))
		
		If tempobj<>Null
	  		' get the node
  			Local tempnode:ISceneNode=ISceneNode.createFromHandle(pISceneNode_forSceneNode,False)
  			' get the attributes
  			Local tempattributes:IAttributes=IAttributes.createFromHandle(pIAttributes_userData,False)
  			' fire the event
	  		tempobj.OnReadUserData(tempnode,tempattributes)
		Else
			Throw "Unable to find bound object"
		EndIf
	EndFunction
	
	Method getBinderHandle:Int()
		Return IrrScene_BMXISceneUserDataSerializer_getBinder(handle)
	EndMethod
			
	'--------------------------------------------
	' create/delete routines
	'--------------------------------------------

	Function create:ISceneUserDataSerializer(pGenFunc:Byte Ptr) Final
		Return createFromHandle(IrrScene_BMXISceneUserDataSerializer_new(),True,pGenFunc)
	EndFunction

	Function createFromHandle:ISceneUserDataSerializer(pHandle:Int,bMustDel:Int,pGenFunc:Byte Ptr) Final
		If Not pHandle Then Return Null
		' use the funtion pointer to generate
		Local generate:ISceneUserDataSerializer()=pGenFunc
		
		Local oRetVal:ISceneUserDataSerializer=generate()

		' turn binding on if this is the first
		oRetVal.bIsBound=bMustDel
		
		oRetVal.attach(pHandle,bMustDel)
		
		Return oRetVal
	EndFunction

EndType

