' ------------------------------------------------------------------------------------
'  irr::scene::ISkinnedMesh wrappers
' ------------------------------------------------------------------------------------
Public

Type ISkinnedMesh Extends IAnimatedMesh Final

	Method getJointCount:Int()
		Return IrrScene_ISkinnedMesh_getJointCount(handle)
	EndMethod
	
	Method getJointName:String(number:Int)
		Return IrrScene_ISkinnedMesh_getJointName(handle, number)
	EndMethod
	
	Method getJointNumber:Int(name:String)
		Return IrrScene_ISkinnedMesh_getJointNumber(handle, name)
	EndMethod
	
	Method useAnimationFrom:Int(other:ISkinnedMesh)
		IrrScene_ISkinnedMesh_useAnimationFrom(handle, other.handle)
	EndMethod
	
	Method updateNormalsWhenAnimating(bOn:Int)
		IrrScene_ISkinnedMesh_updateNormalsWhenAnimating(handle, bOn)
	EndMethod
	
	Method setInterpolationMode(E_INTERPOLATION_MODE:Int)
		IrrScene_ISkinnedMesh_setInterpolationMode(handle, E_INTERPOLATION_MODE)
	EndMethod
	
	Method animateMesh(frame:Float, blend:Float)
		IrrScene_ISkinnedMesh_animateMesh(handle, frame, blend)
	EndMethod
	
	Method skinMesh()
		IrrScene_ISkinnedMesh_skinMesh(handle)
	EndMethod
	
	Method convertMeshToTangents()
		IrrScene_ISkinnedMesh_convertMeshToTangents(handle)
	EndMethod

	Method setHardwareSkinning:Int(bOn:Int)
		Return IrrScene_ISkinnedMesh_setHardwareSkinning(handle, bOn)
	EndMethod
	
	Method isStatic:Int()
		Return IrrScene_ISkinnedMesh_isStatic(handle)
	EndMethod

	Function createFromHandle:ISkinnedMesh(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:ISkinnedMesh=New ISkinnedMesh
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction
	
EndType

Type SPositionKey Extends IrrBase Final

	Method getFrame:Float()
		Return IrrScene_ISkinnedMesh_SPositionKey_getFrame(handle) 
	EndMethod
	
	Method setFrame(frame:Float)
		IrrScene_ISkinnedMesh_SPositionKey_setFrame(handle, frame) 
	EndMethod
	
	Method getPosition:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_ISkinnedMesh_SPositionKey_getPosition(handle), False)
	EndMethod
	
	Method setPosition(position:Vector3df)
		IrrScene_ISkinnedMesh_SPositionKey_setPosition(handle, position.handle) 
	EndMethod

	Function createFromHandle:SPositionKey(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SPositionKey=New SPositionKey
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Function create:SPositionKey()
		Return createFromHandle(IrrScene_ISkinnedMesh_SPositionKey_new(), True)
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrScene_ISkinnedMesh_SPositionKey_del(handle)
	EndMethod	
		
EndType

Type SScaleKey Extends IrrBase Final

	Method getFrame:Float()
		Return IrrScene_ISkinnedMesh_SScaleKey_getFrame(handle) 
	EndMethod
	
	Method setFrame(frame:Float)
		IrrScene_ISkinnedMesh_SScaleKey_setFrame(handle, frame) 
	EndMethod
	
	Method getScale:Vector3df()
		Return Vector3df.createFromHandle(IrrScene_ISkinnedMesh_SScaleKey_getScale(handle), False)
	EndMethod
	
	Method setScale(scale:Vector3df)
		IrrScene_ISkinnedMesh_SScaleKey_setScale(handle, scale.handle) 
	EndMethod

	Function createFromHandle:SScaleKey(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SScaleKey=New SScaleKey
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Function create:SScaleKey()
		Return createFromHandle(IrrScene_ISkinnedMesh_SScaleKey_new(), True)
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrScene_ISkinnedMesh_SScaleKey_del(handle)
	EndMethod	
		
EndType

Type SRotationKey Extends IrrBase Final

	Method getFrame:Float()
		Return IrrScene_ISkinnedMesh_SRotationKey_getFrame(handle) 
	EndMethod
	
	Method setFrame(frame:Float)
		IrrScene_ISkinnedMesh_SRotationKey_setFrame(handle, frame) 
	EndMethod
	
	Method getRotation:Quaternion()
		Return Quaternion.createFromHandle(IrrScene_ISkinnedMesh_SRotationKey_getRotation(handle), False)
	EndMethod
	
	Method setRotation(rotation:Quaternion)
		IrrScene_ISkinnedMesh_SRotationKey_setRotation(handle, rotation.handle) 
	EndMethod

	Function createFromHandle:SRotationKey(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SRotationKey=New SRotationKey
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Function create:SRotationKey()
		Return createFromHandle(IrrScene_ISkinnedMesh_SRotationKey_new(), True)
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrScene_ISkinnedMesh_SRotationKey_del(handle)
	EndMethod	
		
EndType

Type SWeight Extends IrrBase Final

	Method getBufferId:Short()
		Return IrrScene_ISkinnedMesh_SWeight_getBufferId(handle) 
	EndMethod
	
	Method setBufferId(buffer_id:Short)
		IrrScene_ISkinnedMesh_SWeight_setBufferId(handle, buffer_id) 
	EndMethod
	
	Method getVertexId:Int()
		Return IrrScene_ISkinnedMesh_SWeight_getVertexId(handle) 
	EndMethod
	
	Method setVertexId(vertex_id:Int)
		IrrScene_ISkinnedMesh_SWeight_setVertexId(handle, vertex_id)
	EndMethod
	
	Method getStrength:Float()
		Return IrrScene_ISkinnedMesh_SWeight_getStrength(handle) 
	EndMethod
	
	Method setStrength(strength:Float)
		IrrScene_ISkinnedMesh_SWeight_setStrength(handle, strength) 
	EndMethod

	Function createFromHandle:SWeight(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SWeight=New SWeight
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Function create:SWeight()
		Return createFromHandle(IrrScene_ISkinnedMesh_SWeight_new(), True)
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrScene_ISkinnedMesh_SWeight_del(handle)
	EndMethod	
		
EndType

Type SJoint Extends IrrBase Final

Rem

	Function IrrScene_ISkinnedMesh_SJoint_getName$z(pSJoint:Int) 
	Function IrrScene_ISkinnedMesh_SJoint_setName(pSJoint:Int, name$z) 
	'  must delete
	Function IrrScene_ISkinnedMesh_SJoint_getLocalMatrix:Int(pSJoint:Int) ' returns matrix4*
	Function IrrScene_ISkinnedMesh_SJoint_setLocalMatrix(pSJoint:Int, pMatrix4:Int)
	'  must delete
	Function IrrScene_ISkinnedMesh_SJoint_getGlobalMatrix:Int(pSJoint:Int) ' returns matrix4* 
	Function IrrScene_ISkinnedMesh_SJoint_setGlobalMatrix(pSJoint:Int, pMatrix4:Int)
	'  must delete
	Function IrrScene_ISkinnedMesh_SJoint_getGlobalAnimatedMatrix:Int(pSJoint:Int) ' returns matrix4*
	Function IrrScene_ISkinnedMesh_SJoint_setGlobalAnimatedMatrix(pSJoint:Int, pMatrix4:Int)
	'  must delete
	Function IrrScene_ISkinnedMesh_SJoint_getLocalAnimatedMatrix:Int(pSJoint:Int) ' returns matrix4*
	Function IrrScene_ISkinnedMesh_SJoint_setLocalAnimatedMatrix(pSJoint:Int, pMatrix4:Int)
	'  must delete
	Function IrrScene_ISkinnedMesh_SJoint_getGlobalInversedMatrix:Int(pSJoint:Int) ' returns matrix4*
	Function IrrScene_ISkinnedMesh_SJoint_setGlobalInversedMatrix(pSJoint:Int, pMatrix4:Int)
	'  must delete
	Function IrrScene_ISkinnedMesh_SJoint_getAnimatedposition:Int(pSJoint:Int) ' returns vector3df*
	Function IrrScene_ISkinnedMesh_SJoint_setAnimatedposition(pSJoint:Int, pVector3df:Int)
	'  must delete
	Function IrrScene_ISkinnedMesh_SJoint_getAnimatedscale:Int(pSJoint:Int)
	Function IrrScene_ISkinnedMesh_SJoint_setAnimatedscale(pSJoint:Int, pVector3df:Int)
	'  must delete
	Function IrrScene_ISkinnedMesh_SJoint_getAnimatedrotation:Int(pSJoint:Int) ' returns quaternion*
	Function IrrScene_ISkinnedMesh_SJoint_setAnimatedrotation(pSJoint:Int, pQuaternion:Int)
	Function IrrScene_ISkinnedMesh_SJoint_setPositionKeys(pSJoint:Int, SPositionKeys:Int Ptr Ptr, numKeys:Int)
	Function IrrScene_ISkinnedMesh_SJoint_getPositionKeys:Int(pSJoint:Int, keysPtr:Int Ptr Ptr)
	Function IrrScene_ISkinnedMesh_SJoint_setScaleKeys(pSJoint:Int, SScaleKeys:Int Ptr Ptr, numKeys:Int)
	Function IrrScene_ISkinnedMesh_SJoint_getScaleKeys:Int(pSJoint:Int, keysPtr:Int Ptr Ptr)
	Function IrrScene_ISkinnedMesh_SJoint_setRotationKeys(pSJoint:Int, SRotationKeys:Int Ptr Ptr, numKeys:Int)
	Function IrrScene_ISkinnedMesh_SJoint_getRotationKeys:Int(pSJoint:Int, keysPtr:Int Ptr Ptr)
	Function IrrScene_ISkinnedMesh_SJoint_setWeights(pSJoint:Int, SWeights:Int Ptr, numKeys:Int)
	Function IrrScene_ISkinnedMesh_SJoint_getWeights:Int(pSJoint:Int, keysPtr:Int Ptr Ptr)
	Function IrrScene_ISkinnedMesh_SJoint_setChildren(pSJoint:Int, SJoints:Int Ptr, numKeys:Int)
	Function IrrScene_ISkinnedMesh_SJoint_getChildren:Int(pSJoint:Int, keysPtr:Int Ptr Ptr)
	Function IrrScene_ISkinnedMesh_SJoint_setAttachedMeshes(pSJoint:Int, keys:Int Ptr, numKeys:Int)
	Function IrrScene_ISkinnedMesh_SJoint_getAttachedMeshes(pSJoint:Int, keysPtr:Int Ptr)

EndRem

	Function createFromHandle:SJoint(pHandle:Int,bMustDel:Int=False)
		If Not pHandle Then Return Null
		Local oRetVal:SJoint=New SJoint
		oRetVal.attach(pHandle,bMustDel)
		Return oRetVal
	EndFunction

	Function create:SJoint()
		Return createFromHandle(IrrScene_ISkinnedMesh_SJoint_new(), True)
	EndFunction

	Method Delete()
		If (mustdelete) Then IrrScene_ISkinnedMesh_SJoint_del(handle)
	EndMethod	
	
EndType
