Public

' ! Enumeration flags telling the video driver in which format textures
' ! should be created.
' enum E_TEXTURE_CREATION_FLAG

' ! Forces the driver To create 16 bit textures always, indepenent of
' ! which format the file on disk has. When choosing this you may loose
' ! some color detail, but gain much speed And memory. 16 bit textures
' ! can be transferred twice as fast as 32 bit textures And only use 
' ! half of the space in memory.
' ! When using this flag, it does Not make sence To use the flags
' ! ETCF_ALWAYS_32_BIT, ETCF_OPTIMIZED_FOR_QUALITY,
' ! Or ETCF_OPTIMIZED_FOR_SPEED at the same time.
Const ETCF_ALWAYS_16_BIT:Int = $00000001

' ! Forces the driver To create 32 bit textures always, indepenent of
' ! which format the file on disk has. Please note that some drivers 
' ! (like the software device) will ignore this, because they only are
' ! able To create And use 16 bit textures.
' ! When using this flag, it does Not make sence To use the flags
' ! ETCF_ALWAYS_16_BIT, ETCF_OPTIMIZED_FOR_QUALITY,
' ! Or ETCF_OPTIMIZED_FOR_SPEED at the same time.
Const ETCF_ALWAYS_32_BIT:Int = $00000002

' ! Lets the driver decide in which format the texutures are created And
' ! tries To make the textures look as good as possible.
' ! Usually it simply chooses the format in which the texture was stored on disk.
' ! When using this flag, it does Not make sence To use the flags
' ! ETCF_ALWAYS_16_BIT, ETCF_ALWAYS_32_BIT, 
' ! Or ETCF_OPTIMIZED_FOR_SPEED at the same time.
Const ETCF_OPTIMIZED_FOR_QUALITY:Int  = $00000004

' ! Lets the driver decide in which format the texutures are created And
' ! tries To create them maximizing render speed.
' ! When using this flag, it does Not make sence To use the flags
' ! ETCF_ALWAYS_16_BIT, ETCF_ALWAYS_32_BIT, Or ETCF_OPTIMIZED_FOR_QUALITY,
' ! at the same time.
Const ETCF_OPTIMIZED_FOR_SPEED:Int = $00000008

' ! Automaticly creates mip map levels For the textures.
Const ETCF_CREATE_MIP_MAPS:Int = $00000010

' ! Discard any alpha layer and use non-alpha color format.
Const ETCF_NO_ALPHA_CHANNEL:Int = $00000020



